//fat16/32 datei operation Funktionen


/*		extern genutzte funktionen ! siehe file-0.x.h
extern unsigned char ffopen(unsigned char,unsigned char *);// kann immer nur 1 datei bearbeiten.
extern unsigned char ffclose(void);						// muss aufgerufen werden bevor neue datei bearbeitet wird.
extern unsigned char ffseek(unsigned long int);			// setzt zeiger:bytesOfSec auf position in der geöffneten datei.
extern unsigned char ffcd(unsigned char *);				// wechselt direktory
extern unsigned char ffread(void);						// liest byte-weise aus der datei (puffert immer 512 bytes zwischen)
extern unsigned char ffls(void);						// zeigt direktory inhalt an
extern unsigned char ffcdLower(void);					// geht ein direktory zurück, also cd.. (parent direktory)
extern unsigned char ffrm(unsigned char name[]);		// löscht datei aus aktuellem verzeichniss.
extern unsigned char ffmkdir(unsigned char name[]);		// legt ordner in aktuellem verzeichniss an.
*/
//*******************************************************************************************************************************
// nur intern genutzte funktionen ! extern benutzte funktionen siehe : file-0.x.h
unsigned char 	bufferClusterChain(unsigned long int);		// puffert cluster-chain cluster zwischen auf puffer:clusterChain
void 			lsRowsOfClust (unsigned long int start_sec);// zeigt reihen eines clusters an, ab start_sec
//*******************************************************************************************************************************

//register unsigned long int seek asm("r8");		// zählt gelesene bytes, fest registriert in arbeisregister
unsigned long int 	seek;							// zählt gelesene bytes (wird auch von ffseek genutzt)
unsigned char		cntSecOfClust;					// zählt die gelesenen sektoren des clusters (2,4...max 128 siehe secPerCluster)
unsigned char 		file_flag=0;					// 0== datei operation freigegeben, 1==read, 2==write, 3==append

#define ccSize 5									// größe des puffers für die cluster-chain  (vorsicht, sind long int)
unsigned  long int 	clusterChain[ccSize+1];			// puffert ccSize cluster der geöffneten datei 
unsigned  long int 	*ccPointer=&clusterChain[0];	// cluster-chain-Pointer, zeigt auf stelle in puffer:clusterChain

unsigned long int 	currentCluster;					// aktuell bearbeiteter cluster 
unsigned int 		cntOfBytes;						// zäht geschriebene bytes eines sektors

//*******************************************************************************************************************************
// öffnet EINE datei zum lesen/schreiben/anhängen. 
// datei optionen: lesen(1),schreiben/erstellen(2),anhängen(3).
//*******************************************************************************************************************************
unsigned char ffopen(unsigned char option,unsigned char name[]){		

  // datei lesen *******************************************************************************	
  if(option=='r' && file_flag==0){					// option; dateioperation frei.			
	if(0==fat_loadFileDataFromDir(name)){				// läd datei infos aus dem direktory (wechselbar mit ffcd).	
	  bufferClusterChain(file.firstCluster);			// puffert die ersten ccSize(anzahl) cluster der datei.		
	  if(0==fat_loadSector( fat_clustToSec(file.firstCluster) )){	// lät die ersten 512 bytes der datei auf puffer:sector.		
		seek=file.length;								// init von seek, noch keine bytes gelesen.
		cntSecOfClust=1;								// 1.sektor von cluster geladen.
		ccPointer++;									// zeiger++ weil 1. cluster schon geladen.	
		bytesOfSec=&sector[0];							// zeiger auf erstes byte, der datei-bytes.
		file_flag=1;									// 1==file read.				
		return(0);										// alles ok.									
		}					
	  }	
	}
	
  // datei schreiben ***************************************************************************	
  if(option=='w' && file_flag==0){					// option; dateioperation frei.					
		  
	if(0==fat_loadFileDataFromDir(name))return (1);	// prüft ob datei im dir vorhanden, wenn ja, abbruch !			

	  currentCluster=fat_getFreeCluster(0);		// holt neuen freien cluster.  		  
	  fat_setCluster(currentCluster,0x0fffffff);// fat16/32 cluster chain ende setzen.	  
	
	  strcpy((char*)file.name,(char*)name);		// füllen des file struct, zum abschließenden schreiben.
	  file.firstCluster=currentCluster;			// 1. cluster der datei.
	  file.attrib=32;							// file.row wird in der funktion fat_getFreeRowOfDir geschrieben !! 
	  file.length=0;							// zählt geschriebene bytes.

	  cntSecOfClust=1;							// noch kein sektor geschrieben.
	  cntOfBytes=0;								// zählt geschriebene bytes eines sektors.
	  file_flag=2;								// schreiben flag.
	
	  mmc_write_atAddr_start(fat_clustToSec(file.firstCluster));// teilt karte die aktuelle schreib adresse mit
	  return (0);								// alles OK !
	  }

  // datei anhängen ***************************************************************************	
  if(option=='a' && file_flag==0){					// option; dateioperation frei.					
		  
	if(0==fat_loadFileDataFromDir(name)){			// prüft ob datei im dir vorhanden, wenn nicht, abbruch !			

	  unsigned long int end=file.firstCluster;		// variablen, wegen verketteten clustern...
	  unsigned long int start=end;   
 		
	  while(!((end==0xfffffff&&fat.fatType==32)||(end==0xffff&&fat.fatType==16))){	// solange bis ende cluster chain		  
		start=end;		
		end=fat_getNextCluster(end);	
		}			  
	  
		// TODO einfachere methode finden den gewünschten sektor zu bestimmen !!
	  end  = file.length/fat.bytsPerSec;				// end wird hier neu verwendet !
	  unsigned long int c	 = end/fat.secPerClust;				
	  unsigned char	  	s	 = (unsigned char)end-(c*fat.secPerClust);		// s ist sektor des clusters.
	  
	  fat_loadSector(fat_clustToSec(start)+s);			// läd 1. sektor des letzten clusters der datei.
	  bytesOfSec=&sector[0];							// zeigt auf erstes byte des geladenen sektors.
	  mmc_write_atAddr_start(fat_clustToSec(start)+s);	// teilt karte die adresse mit, ab der nun geschrieben wird.
	  // da man immer 512 bytes in folge schreiben muss, wird hier der inhalt der schon da ist nochmal auf die karte geschrieben,
	  // beim schreiben eines sektors (wo nur wenig geändert wurde) passiert nichts anderes...
	  for(cntOfBytes=0;cntOfBytes<(file.length%512);cntOfBytes++)mmc_write_byte(*bytesOfSec++);
	  file_flag=3;
	  cntSecOfClust=1;										
	  return (0);											// alles OK !
	  }
	else return (1);
	}

  return(1);	//fehler?
}


//*******************************************************************************************************************************
// gibt ffopen wieder frei. regelt wenn zum schreiben/anhängen geöffnet war.
// da immer 512 bytes komplett zur karte geschrieben werden müssen, muss noch der rest des sektors,
// der nicht genutzt wurde (beim schreiben/anhängen) voll gemacht werden !!
// erst wenn datei geschlossen wird, wird wenn zum schreiben/erstellen geöffnet wird die datei informationen geschrieben,
// bis hier werden nur die daten geschrieben !
//*******************************************************************************************************************************
unsigned char ffclose(void){  

  if(file_flag>1){								// war zum schreiben/anhängen geöffnet
	unsigned int j=file.length%512;				// errechnet stelle ab der mit 0 überschrieben werden muss				
	while(j<512){									
	  mmc_write_byte(0x00);						// beschreibt ungenutzte bytes mit 0x00 	
	  j++;			
	  }			
	mmc_write_atAddr_end();						// abschluss, schreiben eines blocks

	if(file_flag==2)fat_makeFileEntry(file.name,file.attrib,file.firstCluster,file.length); // macht datei eintrag im aktuellen verzeichniss		

	if(file_flag==3){
	  unsigned long int i=file.length;			// muss gesichert werden, wird sonst von der karte geladen und verändert !	  
	  strcpy((char*)kb_buffer,(char*)file.name);// muss gesichert werden, wird sonst von der karte geladen und verändert !
	  fat_loadFileDataFromDir(kb_buffer);		// läd sektor, des datei eintrags, und läd daten auf struct file!	  	  	  
	  file.length=i;
	  fat_makeRowDataEntry(file.row,file.name,0x20,file.firstCluster,file.length);	 // macht eintrag im puffer
	  fat_writeSector(fat.currentSectorNr);									 // schreibt puffer auf karte
	  }
	}

  file_flag=0;		
  cntSecOfClust=0;
  seek=0;		
  cntOfBytes=0;
  return(0);	
}




//***************************************************************************************PhysFS****************************************
// wechselt verzeichniss. start immer im root Dir.
// MUSS in das direktory gewechselt werden, in dem die datei zum lesen/schreiben ist !
//*******************************************************************************************************************************
unsigned char ffcd(unsigned char name[]){	
	if(0==fat_cd(name))return(0);
	return(1);
}


//*******************************************************************************************************************************
// zeigt reihen eines clusters an, wird für ffls benötigt !
// es wird ab dem start sektor start_sec, der dazugehörige cluster angezeigt. geprüft wird ob es ein richtiger 
// eintrag in der reihe ist (nicht gelöscht, nicht frei usw). die sektoren des clusters werden nachgeladen.
// die dateien werden mit namen und datei größe angezeigt.
//*******************************************************************************************************************************
void lsRowsOfClust (unsigned long int start_sec){

  unsigned char row;						// reihen
  unsigned char sec=0;						// sektoren 
  
  do{
	fat_loadSector(start_sec + sec);			
	for(row=0;row<16;row++){								// geht durch reihen des sektors	
	  fat_loadRowOfSector(row);				
	  if((file.attrib==0x20||file.attrib==0x10) && (file.name[0]!=0xE5&&file.name[0]!=0x00)){	  
	  uputs((char*)file.name);
	  uputs(" ");
   	  ultoa(file.length,(char*)kb_buffer,10);
   	  uputs((char*)kb_buffer);			
//  	  printf("%lu",file.length);
	  uputs("\n\r");
	  }
	}
	sec++;
	}while(sec<fat.secPerClust);
}


//*******************************************************************************************************************************
// zeigt inhalt eines direktory an.
// unterscheidung ob man sich im rootDir befindet nötig, weil bei fat16 im root dir eine bestimmt anzahl sektoren durchsucht
// werden müssen und bei fat32 ab einem start cluster ! ruft lsRowsOfClust auf um cluster/sektoren anzuzeigen.
//*******************************************************************************************************************************
unsigned char ffls(void){
// #if smallFatSys 
  unsigned long int clust;											// cluster
  unsigned int s;													// fat16 root dir sektoren

  if(fat.dir==0 && fat.fatType==16){							// IM ROOTDIR.	fat16		
	for(s=0;s<(unsigned int)(fat.dataDirSec+2-fat.rootDir);s++){	// zählt durch RootDir sektoren (errechnet anzahl rootDir sektoren).	
	  lsRowsOfClust(fat.rootDir+s);									// zeigt reihen eines root dir clust an
	  }
	}

  else {		
	if(fat.dir==0 && fat.fatType==32)clust=fat.rootDir;			// IM ROOTDIR.	fat32		
	else clust=fat.dir;											// NICHT ROOT DIR																
	while( !((clust==0xfffffff&&fat.fatType==32)||(clust==0xffff&&fat.fatType==16)) ){	// prüft ob weitere sektoren zum lesen da sind (fat32||fat16)	
	  lsRowsOfClust(fat_clustToSec(clust));												// zeigt reihen des clusters an
	  clust=fat_getNextCluster(clust);													// liest nächsten cluster des dir-eintrags
	  }
	}
// #endif
  return(0);
}



#if smallFileSys 		// *******************************************************************************************************

// *******************************************************************************************************************************
// übergabe ist die position ab der gelesen werden soll (offset)!!
// (läd den absoluten sektor, des clusters auf puffer:sector, setzt den zeiger auf das gewünschte byte.)
// es wird die position des gewünschten clusters in der cluster chain errechnet(c) und der sektor(s) in dem cluster, dann wird 
// durch die cluster chain gegangen, bis der gewünschte cluster erreicht ist. der errechnete sektor in dem cluster wird geladen.
// unterscheidung noch ob man sich im ersten sektor des ersten clusters befindet (c=0 s=0 tmp=0).
// *******************************************************************************************************************************
unsigned char ffseek(unsigned long int offset){				

  if(file_flag!=0){										// datei operation freigegeben
			
	unsigned long int tmp = offset/fat.bytsPerSec;		// berechnungs temp variable (anzahl der sektoren, abgerundet)
	unsigned long int c	 = tmp/fat.secPerClust;			// cluster position in der chain	(abgerundet)			
	unsigned char	  s	 = tmp-(c*fat.secPerClust);		// sektor des clusters in dem das byte mit position:offset ist	
	unsigned long int i	 = c+1;							// zählt die cluster ab, +1 weil vorher abgerundet	

	seek-=offset;								// übersprungene bytes abziehen 
	bufferClusterChain(file.firstCluster);		// start 1. cluster der datei (while schleife sucht den richtigen von anfang an)

	while(--i){									// sucht den gewünschten cluster aus der fat 		
	  ccPointer++;								// zeigt auf clusteradresse im puffer:clusterChain				
	  if(ccPointer==&clusterChain[ccSize]) bufferClusterChain(*ccPointer);		// weiter laden der chain wenn gepufferte nicht ausreichen
	  }

    if(0==fat_loadSector( fat_clustToSec(*ccPointer) +s )){							// läd den sektor mit der byte position:offset
	  ccPointer++;																	// zeigt auf nächsten cluster, weil grade einen glesen
	  bytesOfSec=&sector[0];														// byte zeiger auf 1. stelle					
	  if(offset<fat.bytsPerSec)	bytesOfSec+=fat.bytsPerSec-(fat.bytsPerSec-offset);	// byte offset | kleiner 1. sektor
	  else 						bytesOfSec+=offset-tmp*fat.bytsPerSec;				// byte offset | größer  1. sektor
	  cntSecOfClust=s+1;															// sektor offset	(+1 weil einen grade geladen)			
	  return(0);		
	  }
  }

  return(1);	
}


//*******************************************************************************************************************************
// wechselt in das parent verzeichniss (ein verzeichniss zurück !)
// die variable fat.dir enthält den start cluster des direktory in dem man sich grade befindet, anhand diesem,
// kann der "." bzw ".." eintrag im ersten sektor des direktory ausgelesen und das parent direktory bestimmt werden.
//*******************************************************************************************************************************
unsigned char ffcdLower(void){

	if(fat.dir==0)return(1);							// im root dir, man kann nicht höher !
	
	fat_loadSector(fat_clustToSec(fat.dir));			// läd 1. sektor des aktuellen direktory.
	fat_loadRowOfSector(1);								// ".." eintrag (parent dir) ist 0 wenn parent == root

	if(file.firstCluster==0)fat.dir=0;					// zum root dir
	else fat.dir=file.firstCluster;						// nicht zum root dir
	
	return(0);
}


//*******************************************************************************************************************************
// löscht datei aus aktuellem verzeichniss, wenn es die datei gibt.
// geht nur wenn keine schreib/lese/anhäng vorgänge statfinden. löscht nur dateien !
//*******************************************************************************************************************************
unsigned char ffrm(unsigned char name[]){

  if(0==fat_loadFileDataFromDir(name) && file_flag==0){	// datei gibt es nicht oder file operation, abbruch.

	if(file.attrib!=0x10){			// ist datei.	
	  sector[file.row<<5]=0xE5;		// datei gelöscht markieren (file.row*32, damit man auf reihen anfang kommt)
	  if((file.row-1)>=0){			// gibt es einen eintrag davor ?
	  if(sector[(file.row<<5)-21]==0x0f)sector[(file.row<<5)-32]=0xE5;	// langer datei eintag auch gelöscht.
		}	
	  bufferDirty=1;								// eintrag in puffer gemacht. 	  
	  fat_delClusterChain(file.firstCluster);		// löscht die zu der datei gehörige cluster-chain aus der fat.
	  return(0);
	  }
 
  //TODO noch nicht optimal. zu viele schreib vorgänge beim löschen von datei einträgen. bis zu 16/sektor !
  else{									// ist ordner, rekursiv löschen !!
	unsigned long int parent;
	unsigned long int own;
	unsigned long int clustsOfDir;		// um durch die cluster chain eines dirs zu gehen.
	unsigned char i=0;

	sector[file.row<<5]=0xE5;		// löscht dir eintrag
	if((file.row-1)>=0){			// gibt es einen eintrag davor (langer datei eintrag)?
	  if(sector[(file.row<<5)-21]==0x0f)sector[(file.row<<5)-32]=0xE5;	// langer datei eintag auch gelöscht
	  }
	bufferDirty=1;					// puffer eintrag gemacht
		
	parent=fat.dir;										// der ordner in dem der zu löschende ordner ist.
	own=file.firstCluster;								// der 1. cluster des ordners der zu löschen ist.
	clustsOfDir=file.firstCluster;						// die "cluster" des zu löschenden ordners
	cntSecOfClust=0;									// 0 sektoren bearbeitet

	do{													// geht durch cluster des dirs							
	  fat_loadSector(fat_clustToSec(clustsOfDir));		// sektor des dirs laden
	  do{												// geht durch sektoren des clusters
		do{	  											// geht durch reihen des sektors
		  fat_loadRowOfSector(i);

		  if(file.attrib!=0x10 && file.attrib!=0x00 && file.name[0]!=0xE5){	// ist kein ordner,noch nicht gelöscht, kein freier eintrag
			sector[i<<5]=0xE5;									// erster eintrag der reihe als gelöscht markiert		
			bufferDirty=1;										// puffer eintrag gemacht
			if(file.attrib==0x20){								// ist datei!
			  fat_delClusterChain(file.firstCluster);						// ist datei, dann cluster-chain der datei löschen
			  fat_loadSector(fat_clustToSec(clustsOfDir)+cntSecOfClust);	// sektor neu laden, weil löschen der chain, den puffer nutzt.			
			  }
			}

		  if(file.attrib==0x10&&file.name[0]=='.'){				// "." oder ".." eintrag erkannt, löschen !
			sector[i<<5]=0xE5;									// eintrag als gelöscht markiert		
			bufferDirty=1;										// puffer eintrag gemacht		  
			}

		  if(file.attrib==0x10&&file.name[0]!='.'&&file.name[0]!=0xE5){	// ordner erkannt. löschen und rein wechseln !
			sector[i<<5]=0xE5;									// dir eintrag als gelöscht markiert		
			bufferDirty=1;										// puffer eintrag gemacht		  
			fat_loadSector(fat_clustToSec(file.firstCluster));	// sektor des dirs laden		  
			clustsOfDir=file.firstCluster;						// eigenes dir ist file.firstCluster
			own=file.firstCluster;								// eigener start cluster/dir
			fat_loadRowOfSector(1);								// ".." laden um parent zu bestimmen
			parent=file.firstCluster;							// parent sichern.		  
			cntSecOfClust=0;									// init von gelesenen sektoren und reihen !
			i=0;
			continue;
			}

		  if(file.name[0]==0x00){								// ende des dirs erreicht, wenn nicht voll !!				  
			if(parent==fat.dir){								// erfolgreich alles gelöscht
			  fat_delClusterChain(own);							// cluster chain des ordners löschen
			  return(0);
			  }
			fat_delClusterChain(own);							// cluster chain des ordners löschen
			clustsOfDir=parent;									// parent ist jetzt wieder arbeisverzeichniss.		 
			own=parent;											// arbeitsverzeichniss setzten
			fat_loadSector(fat_clustToSec(own));				// sektor des dirs laden
			fat_loadRowOfSector(1);								// ".." laden um parent zu bestimmen
			parent=file.firstCluster;		  		  			// parent sichern.
			cntSecOfClust=0;									// init von gelesenen sektoren und reihen !
			i=0;
			continue;
			}
	  
		  i++;
		  }while(i<16);													// geht durch reihen des sektors.
	
		i=0;															// neuer sektor -> reihen von vorne.
		cntSecOfClust++;	  											
		fat_loadSector(fat_clustToSec(clustsOfDir)+cntSecOfClust);		// läd sektoren des clusters nach
		}while(cntSecOfClust<fat.secPerClust);							// geht durch sektoren des clusters.

	  cntSecOfClust=0;													// neuer cluster -> sektoren von vorne.
	  clustsOfDir=fat_getNextCluster(clustsOfDir);						// sucht neuen cluster der cluster-chain.	  
	  }while(!((clustsOfDir==0xfffffff&&fat.fatType==32)||(clustsOfDir==0xffff&&fat.fatType==16)));		// geht durch cluster des dirs.
	  fat_delClusterChain(own);				// hier landet man, wenn der ordner voll war !!
	  }

  }

  return(1);				// fehler
}


// *******************************************************************************************************************************
// erstellt einen dir eintrag im aktuellen verzeichniss (geht nur wenn keine lese/schreib usw. vorgänge).
// prüft ob es den den dir-namen:name schon gibt, dann wird nichts angelegt.
// wenn ok, dann wird ein freier cluster gesucht, als ende markiert, der eintrag ins dir geschrieben.
// dann wird der cluster des dirs aufbereitet. der erste sektor des clusters enthält den "." und ".." eintrag.
// der "." hat den 1. cluster des eigenen dirs. der ".." eintrag ist der 1. cluster des parent dirs.
// ein dir wird immer mit 0x00 initialisiert ! also alle sektoren des clsters ( bis auf . und .. einträge)!
// *******************************************************************************************************************************
unsigned char ffmkdir(unsigned char name[]){

  if(0==fat_loadFileDataFromDir(name)||file_flag!=0)return (1);	// prüft ob dirname im dir schon vorhanden, wenn ja, abbruch !			

  currentCluster=fat_getFreeCluster(0);				// holt neuen freien cluster.  		  
  fat_setCluster(currentCluster,0x0fffffff);		// fat16/32 cluster chain ende setzen.	  

  fat_makeFileEntry(name,0x10,currentCluster,0); 	// macht dir eintrag im aktuellen verzeichniss	

  // aufbereiten des neuen dir clusters !
  fat_markSector00();					// löschen des sektors (nur im puffer).
  fat_makeRowDataEntry(0,(unsigned char *)strings(PSTR(".           ")),0x10,currentCluster,0);	// macht "." eintrag des dirs
//   fat_makeRowDataEntry(0,".           ",0x10,currentCluster,0);		// macht "." eintrag des dirs
//   fat_makeRowDataEntry(1,"..          ",0x10,fat.dir,0);			// macht ".." eintrag des dirs
  fat_makeRowDataEntry(1,(unsigned char *)strings(PSTR("..          ")),0x10,fat.dir,0);			// macht ".." eintrag des dirs
  fat_writeSector(fat_clustToSec(currentCluster));					// schreibt einträge auf karte !

  fat_markSector00();					// löschen des sektors (nur im puffer).  
  unsigned char i;
  for(i=1;i<fat.secPerClust;i++){		// ein dir cluster muss mit 0x00 initialisiert werden !
	fat_writeSector(fat_clustToSec(currentCluster)+i);	// löschen des cluster (überschreibt mit 0x00), wichtig bei ffls!
	}	
 
  return(0);

}


#endif				// *******************************************************************************************************


//*******************************************************************************************************************************
// liest ein byte aus der geöffneten datei.
// läd sektoren der datei nach. wenn ein cluster mehrere sektoren hat, dann werden diese nacheinander gelesen.
// puffert die cluster chain der datei zwischen.
// gibt bytes der datei zurück (immer 1 byte ). 
//*******************************************************************************************************************************
unsigned char ffread(void){
	
  if(file_flag!=1)return(1);						// datei zum lesen geöffnet	(nur dann lesen möglich)										

  if(bytesOfSec==&sector[512]){						// einen sektor der datei gelesen 															
	if(cntSecOfClust<fat.secPerClust){				// nächsten sektor des clusters lesen, wenn mehrere sektoren/cluster
	  fat_loadSector(fat.currentSectorNr+1);		// nächsten sektor auf puffer:sector geladen				
	  bytesOfSec=&sector[0];						// zurücksetzten von byte zeiger (gelesene bytes des sektors)
	  cntSecOfClust++;								// gelesene sektoren des clusters hochzählen
	  }
	else {		
	  if(ccPointer==&clusterChain[ccSize]) bufferClusterChain(*ccPointer);	// weiter laden der chain, wenn nötig					
	  if(0==fat_loadSector( fat_clustToSec(*ccPointer) )) {		// läd neuen sektor auf puffer:sector(absoluter sektor)					
		ccPointer++;								// cluster gelesen, auf nächsten zeigen
		bytesOfSec=&sector[0];						// byte zeiger auf erstes byte setzten
		cntSecOfClust=1;							// 1. sektor des clusters gelesen	
		}
	  }		
	}		
  return *bytesOfSec++;								// rückgabe, bytes des sektors				
}



//*******************************************************************************************************************************
// schreibt ein byte der geöffneten datei, direkt auf die karte. wenn ein neuer cluster benötigt wird, wird dieser gesucht und
// verkettet. es werden alle sektoren eines clusters beschrieben.
// die karte bekommt die schreib adresse mitgeteilt, danach müssen 512 bytes in folge kommen, schreib aktion wird beendet,
// dann kann neuer sektor beschrieben werden (beschreibt sektoren von clustern). ist ein cluster beschrieben,
// wird ein neuer gesucht, verkettet und schreiben geht weiter.
//*******************************************************************************************************************************
unsigned char ffwrite(unsigned char c){
	
	if(file_flag>1){											// prüft ob datei operation w oder a.
	mmc_write_byte(c);											// c auf karte schreiben
	cntOfBytes++;												// zähler für geschriebene bytes eines sekors
	file.length++;												// geschriebene bytes erhöhen		

	if(cntOfBytes==512){								// SEKTOR GESCHRIEBEN ( 2 möglichkeiten ab hier !)	
	  mmc_write_atAddr_end();									// abschluss schreiben eines sektors
	  cntOfBytes=0;												// init des zählers
	  if(cntSecOfClust<fat.secPerClust){				// 1. MEHRERE SEKTOREN pro CLUSTER				
		mmc_write_atAddr_start(fat_clustToSec(currentCluster)+cntSecOfClust); // teilt karte neue adresse mit				
		cntSecOfClust++;									// geschriebene sektoren des clusters erhöhen	
		return (0);
		}
	  else{												// 2. NEUER CLUSTER NÖTIG (alle sektoren des clusters geschrieben)			
		unsigned long int clusterOld=currentCluster;		// tmp variable zum verketten der cluster				
		cntSecOfClust=1;									
		currentCluster=fat_getFreeCluster(clusterOld);		// holt neuen freien cluster		
		fat_setCluster(clusterOld,currentCluster);			// cluter chain verketten
		fat_setCluster(currentCluster,0xfffffff);			// cluster chain ende		
		mmc_write_atAddr_start(fat_clustToSec(currentCluster));	// teilt karte neue adresse mit				
		return (0);
		}				
	  }		

 	return (0);
	}

  return (1);
}


//*******************************************************************************************************************************
// puffert cluster-chain einer datei die zum lesen geöffnet ist.
// läd die cluster-chain der datei und puffert diese auf: clusterChain	(immer ccSize cluster). beschleunigt lesen, weil nicht
// immer 512 bytes der fat gelesen werden müssen,  um den nächsten cluster zu bestimmen(braucht mehr ram).
// man müsste 512 bytes lesen um an die nächsten 512 bytes daten zu kommen, macht 1KB für 1/2KB daten = overhead von 50 prozent.
//*******************************************************************************************************************************
unsigned char bufferClusterChain(unsigned long int firstCluster){
	
  unsigned char i=ccSize;			// sooft wie ccSize groß puffern
  unsigned char k=0;		
					
  ccPointer=clusterChain	;		// init des zeigers
  clusterChain[0]=firstCluster;		// letzter cluster ist der start zum suchen
	
  do{		
	clusterChain[k+1]=fat_getNextCluster(clusterChain[k]);				// liest cluster aus fat und puffer diese		
	if( (clusterChain[k+1]==0xfffffff && fat.fatType==32) || (clusterChain[k+1]==0xffff && fat.fatType==16) )return(0);// cluster chain ende zeichen  
	k++;					
	}while(--i);
	
  return(1);
}







